---
title: YAGSL (Swerve)
lang: fr
---

[Yet Another Generic Swerve Library](https://github.com/BroncBotz3481/YAGSL) permet de facilement créer un sous-système swerve pour un robot.

Plus d'information sera ajoutée, mais pour l'instant vous pouvez suivre la documentation [ici](https://yagsl.gitbook.io/yagsl)

## Installation

Installer les [bibliothèques](./vendor_libraries) de NavX, Phoenix, REV et YAGSL.

## Configuration

Pour utiliser la bibliothèque, nous devons lui fournir des fichiers de configuration qui décrivent notre système swerve (les différents moteurs et leurs ID, entre autres).

Vous pouvez donc aller chercher le dossier d'[exemple](https://github.com/BroncBotz3481/YAGSL/tree/main/deploy) ou le [créer vous-même](https://broncbotz3481.github.io/YAGSL-Example/). Vous devez mettre le dossier `swerve` dans le dossier `deploy` de votre projet.

## Utilisation

1. Créer un subsystem pour le swerve
2. Créer une variable `SwerveDrive`
3. Créer le `SwerveDrive` à partir de la configuration

```java
double maximumSpeed = Units.feetToMeters(4.5)
File swerveJsonDirectory = new File(Filesystem.getDeployDirectory(),"swerve");
SwerveDrive  swerveDrive = new SwerveParser(directory).createSwerveDrive(maximumSpeed);
```

Vous devrez ensuite ajouter vos méthodes pour intéragir avec le `SwerveDrive` dans le subsystem.

```java
swerveDrive.drive(new Translation2d(
  translationX.getAsDouble() * swerveDrive.getMaximumVelocity(),
  translationY.getAsDouble() * swerveDrive.getMaximumVelocity()),
  angularRotationX.getAsDouble() * swerveDrive.getMaximumAngularVelocity(),
  true,
  false);
```
